MockEcoFpha = [
    "***********************************************************************\n",
    "*                                                                     *\n",
    "*            CEPEL - CENTRO DE PESQUISAS DE ENERGIA ELETRICA          *\n",
    "*  CEPEL: NEWAVE     - Versao FPHA_NEWAVE                             *\n",
    "*                                                                     *\n",
    "***********************************************************************\n",
    "\n",
    "\n",
    "____________________________________________________________________\n",
    "\n",
    " Backtest CPAMP 2022-2023 - CVaR 25x35 NEWAVE 02/2022                            \n",
    "____________________________________________________________________\n",
    "\n",
    "\n",
    "---------------------------------------------------------------------------------\n",
    "Relatorio de dados para a modelagem da funcao de producao das usinas hidroeletricas\n",
    "---------------------------------------------------------------------------------\n",
    "----;----;-------------;----;----;----;----;-----;--------;--------;-----;--------;--------;--------;--------;\n",
    "USIH;IPER;    Nome     ;      Opcoes    ;;;;     Discretiz. Q    ;;;    Discretiz. V     ;;;    Janela GH   ;;\n",
    "  - ;    ;     -       ;Tipo;Conv;Alfa;Rems; Npt ;   Qmin ;  Qmax  ; Npt ;  Vmin  ;  Vmax  ;  GHmin ; GHmax  ;\n",
    "  - ;    ;             ;    ;    ;    ;    ;     ; (m3/s) ; (m3/s) ;     ; (hm3)  ; (hm3)  ;  (MW)  ;  (MW)  ;\n",
    "----;----;-------------;----;----;----;----;-----;--------;--------;-----;--------;--------;--------;--------;\n",
    "   4;   1; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;   2; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;   3; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;   4; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;   5; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;   6; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;   7; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;   8; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;   9; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;  10; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;  11; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;  12; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "   4;  13; FUNIL-GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   507.2;    1;   265.9;   265.9;     0.0;   180.0;\n",
    "  20;   1; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;   2; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;   3; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;   4; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;   5; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;   6; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;   7; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;   8; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;   9; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;  10; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;  11; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;  12; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  20;  13; BATALHA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   151.2;    5;   430.0;  1520.8;     0.0;    52.5;\n",
    "  21;   1; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;   2; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;   3; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;   4; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;   5; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;   6; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;   7; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;   8; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;   9; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;  10; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;  11; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;  12; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  21;  13; SERRA FACAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   313.5;    5;  1752.0;  3503.1;     0.0;   212.6;\n",
    "  27;   1; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;   2; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;   3; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;   4; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;   5; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;   6; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;   7; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;   8; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;   9; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;  10; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;  11; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;  12; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  27;  13; CAPIM BRANC1;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   471.3;    5;   228.3;   234.7;     0.0;   240.0;\n",
    "  28;   1; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;   2; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;   3; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;   4; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;   5; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;   6; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;   7; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;   8; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;   9; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;  10; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;  11; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;  12; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  28;  13; CAPIM BRANC2;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   503.7;    1;   867.5;   867.5;     0.0;   210.0;\n",
    "  29;   1; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;   2; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;   3; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;   4; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;   5; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;   6; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;   7; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;   8; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;   9; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;  10; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;  11; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;  12; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  29;  13; CORUMBA IV  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   227.6;    5;  2936.6;  3437.2;     0.0;   129.2;\n",
    "  48;   1; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;   2; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;   3; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;   4; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;   5; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;   6; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;   7; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;   8; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;   9; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;  10; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;  11; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;  12; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  48;  13; PIRAJU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   346.9;    1;   105.4;   105.4;     0.0;    80.0;\n",
    "  66;   1; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;   2; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;   3; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;   4; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;   5; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;   6; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;   7; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;   8; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;   9; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;  10; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;  11; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;  12; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    "  66;  13; ITAIPU      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13032.8;    1; 27914.0; 27914.0;     0.0; 14000.0;\n",
    " 131;   1; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;   2; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;   3; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;   4; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;   5; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;   6; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;   7; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;   8; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;   9; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;  10; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;  11; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;  12; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 131;  13; NILO PECANHA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   139.7;    1;     9.0;     9.0;     0.0;   380.0;\n",
    " 132;   1; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;   2; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;   3; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;   4; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;   5; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;   6; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;   7; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;   8; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;   9; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;  10; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;  11; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;  12; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 132;  13; FONTES      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    48.9;    1;   393.8;   393.8;     0.0;   132.0;\n",
    " 141;   1; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;   2; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;   3; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;   4; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;   5; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;   6; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;   7; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;   8; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;   9; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;  10; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;  11; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;  12; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 141;  13; BAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   824.5;    1;    32.5;    32.5;     0.0;   140.0;\n",
    " 153;   1; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;   2; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;   3; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;   4; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;   5; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;   6; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;   7; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;   8; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;   9; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;  10; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;  11; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;  12; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 153;  13; SAO DOMINGOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.3;    1;   131.3;   131.3;     0.0;    48.0;\n",
    " 155;   1; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;   2; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;   3; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;   4; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;   5; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;   6; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;   7; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;   8; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;   9; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;  10; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;  11; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;  12; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 155;  13; RETIRO BAIXO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   254.6;    5;   221.2;   241.6;     0.0;    83.7;\n",
    " 156;   1; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;   2; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;   3; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;   4; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;   5; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;   6; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;   7; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;   8; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;   9; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;  10; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;  11; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;  12; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 156;  13; TRES MARIAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   876.7;    5;  9643.1; 19528.0;     0.0;   396.0;\n",
    " 162;   1; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;   2; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;   3; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;   4; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;   5; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;   6; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;   7; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;   8; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;   9; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;  10; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;  11; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;  12; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 162;  13; QUEIMADO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    66.0;    5;    95.2;   534.4;     0.0;   105.0;\n",
    " 195;   1; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;   2; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;   3; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;   4; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;   5; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;   6; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;   7; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;   8; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;   9; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;  10; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;  11; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;  12; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 195;  13; JAURU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   126.9;    1;    16.9;    16.9;     0.0;   118.0;\n",
    " 196;   1; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;   2; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;   3; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;   4; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;   5; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;   6; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;   7; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;   8; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;   9; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;  10; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;  11; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;  12; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 196;  13; GUAPORE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.7;    1;    22.5;    22.5;     0.0;   120.0;\n",
    " 203;   1; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;   2; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;   3; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;   4; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;   5; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;   6; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;   7; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;   8; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;   9; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;  10; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;  11; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;  12; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 203;  13; CORUMBA III ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   287.0;    5;   709.0;   928.1;     0.0;    96.4;\n",
    " 227;   1; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;   2; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;   3; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;   4; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;   5; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;   6; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;   7; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;   8; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;   9; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;  10; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;  11; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;  12; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 227;  13; SINOP       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1547.7;    5;  1012.4;  2546.2;     0.0;   401.9;\n",
    " 228;   1; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;   2; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;   3; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;   4; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;   5; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;   6; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;   7; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;   8; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;   9; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;  10; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;  11; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;  12; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 228;  13; COLIDER     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1443.7;    1;  1495.4;  1495.4;     0.0;   300.0;\n",
    " 229;   1; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;   2; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;   3; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;   4; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;   5; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;   6; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;   7; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;   8; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;   9; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;  10; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;  11; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;  12; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 229;  13; TELES PIRES ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3601.1;    1;   961.1;   961.1;     0.0;  1820.0;\n",
    " 230;   1; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;   2; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;   3; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;   4; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;   5; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;   6; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;   7; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;   8; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;   9; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;  10; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;  11; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;  12; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 230;  13; SAO MANOEL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3245.9;    1;   566.1;   566.1;     0.0;   735.8;\n",
    " 241;   1; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;   2; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;   3; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;   4; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;   5; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;   6; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;   7; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;   8; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;   9; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;  10; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;  11; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;  12; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 241;  13; SLT VERDINHO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   248.5;    1;   392.6;   392.6;     0.0;    93.0;\n",
    " 249;   1; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;   2; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;   3; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;   4; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;   5; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;   6; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;   7; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;   8; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;   9; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;  10; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;  11; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;  12; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 249;  13; OURINHOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   458.4;    1;    20.9;    20.9;     0.0;    44.1;\n",
    " 251;   1; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;   2; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;   3; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;   4; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;   5; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;   6; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;   7; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;   8; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;   9; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;  10; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;  11; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;  12; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 251;  13; SERRA MESA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1109.0;    5; 11150.0; 42549.5;     0.0;  1275.0;\n",
    " 252;   1; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;   2; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;   3; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;   4; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;   5; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;   6; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;   7; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;   8; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;   9; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;  10; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;  11; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;  12; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 252;  13; CANA BRAVA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1163.4;    1;  2237.8;  2237.8;     0.0;   450.0;\n",
    " 253;   1; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;   2; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;   3; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;   4; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;   5; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;   6; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;   7; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;   8; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;   9; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;  10; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;  11; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;  12; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 253;  13; SAO SALVADOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1131.7;    1;   936.3;   936.3;     0.0;   243.2;\n",
    " 257;   1; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;   2; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;   3; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;   4; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;   5; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;   6; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;   7; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;   8; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;   9; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;  10; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;  11; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;  12; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 257;  13; PEIXE ANGIC ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2088.0;    5;  2476.8;  2741.0;     0.0;   498.8;\n",
    " 261;   1; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;   2; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;   3; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;   4; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;   5; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;   6; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;   7; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;   8; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;   9; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;  10; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;  11; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;  12; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 261;  13; LAJEADO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2722.5;    1;  5003.1;  5003.1;     0.0;   902.5;\n",
    " 262;   1; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;   2; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;   3; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;   4; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;   5; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;   6; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;   7; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;   8; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;   9; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;  10; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;  11; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;  12; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 262;  13; SALTO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   257.7;    1;   820.4;   820.4;     0.0;   116.0;\n",
    " 276;   1; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;   2; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;   3; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;   4; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;   5; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;   6; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;   7; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;   8; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;   9; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;  10; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;  11; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;  12; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 276;  13; RONDON II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    5;   192.2;   335.2;     0.0;    73.5;\n",
    " 281;   1; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;   2; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;   3; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;   4; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;   5; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;   6; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;   7; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;   8; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;   9; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;  10; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;  11; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;  12; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 281;  13; PONTE PEDRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    77.6;    1;    92.6;    92.6;     0.0;   176.1;\n",
    " 285;   1; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26806.9;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;   2; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26806.9;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;   3; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26472.4;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;   4; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26444.5;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;   5; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26997.8;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;   6; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26614.6;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;   7; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26637.9;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;   8; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26014.1;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;   9; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 25778.9;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;  10; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 25853.8;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;  11; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26363.9;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;  12; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26939.7;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 285;  13; JIRAU       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 26959.0;    1;  2746.7;  2746.7;     0.0;  3750.0;\n",
    " 287;   1; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 28650.5;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;   2; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 28650.5;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;   3; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 27846.5;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;   4; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 28245.7;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;   5; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 28297.4;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;   6; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 24507.6;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;   7; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 20649.9;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;   8; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 17779.3;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;   9; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 16729.0;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;  10; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 17163.5;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;  11; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 18950.1;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;  12; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 23185.8;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 287;  13; STO ANTONIO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 27942.8;    1;  2282.8;  2282.8;     0.0;  3568.3;\n",
    " 290;   1; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;   2; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;   3; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;   4; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;   5; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;   6; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;   7; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;   8; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;   9; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;  10; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;  11; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;  12; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 290;  13; ESPORA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    70.0;    5;   140.0;   209.0;     0.0;    32.0;\n",
    " 304;   1; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;   2; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;   3; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;   4; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;   5; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;   6; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;   7; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;   8; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;   9; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;  10; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;  11; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;  12; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 304;  13; ITIQUIRA I  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    79.1;    1;     5.0;     5.0;     0.0;    60.8;\n",
    " 305;   1; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;   2; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;   3; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;   4; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;   5; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;   6; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;   7; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;   8; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;   9; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;  10; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;  11; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;  12; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 305;  13; ITIQUIRA II ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    78.9;    1;     1.0;     1.0;     0.0;    96.6;\n",
    " 310;   1; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;   2; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;   3; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;   4; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;   5; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;   6; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;   7; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;   8; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;   9; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;  10; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;  11; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;  12; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 310;  13; DARDANELOS  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   300.4;    1;     0.9;     0.9;     0.0;   261.0;\n",
    " 311;   1; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;   2; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;   3; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;   4; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;   5; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;   6; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;   7; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;   8; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;   9; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;  10; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;  11; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;  12; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 311;  13; CACU        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   269.5;    5;   211.6;   227.4;     0.0;    65.0;\n",
    " 312;   1; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;   2; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;   3; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;   4; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;   5; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;   6; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;   7; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;   8; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;   9; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;  10; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;  11; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;  12; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 312;  13; B. COQUEIROS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   280.0;    1;   321.4;   321.4;     0.0;    90.0;\n",
    " 315;   1; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;   2; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;   3; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;   4; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;   5; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;   6; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;   7; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;   8; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;   9; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;  10; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;  11; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;  12; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 315;  13; FOZ R. CLARO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   285.6;    1;    96.7;    96.7;     0.0;    68.4;\n",
    " 119;   1; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;   2; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;   3; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;   4; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;   5; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;   6; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;   7; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;   8; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;   9; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;  10; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;  11; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;  12; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 119;  13; HENRY BORDEN;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   156.5;    1;     0.5;     0.5;     0.0;   889.0;\n",
    " 120;   1; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;   2; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;   3; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;   4; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;   5; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;   6; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;   7; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;   8; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;   9; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;  10; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;  11; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;  12; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 120;  13; JAGUARI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    59.9;    5;   443.0;  1133.7;     0.0;    27.6;\n",
    " 121;   1; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;   2; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;   3; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;   4; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;   5; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;   6; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;   7; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;   8; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;   9; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;  10; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;  11; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;  12; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 121;  13; PARAIBUNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   124.5;    5;  2396.5;  4732.0;     0.0;    87.0;\n",
    " 122;   1; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;   2; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;   3; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;   4; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;   5; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;   6; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;   7; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;   8; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;   9; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;  10; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;  11; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;  12; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 122;  13; SANTA BRANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.0;    5;   252.7;   439.0;     0.0;    56.0;\n",
    " 123;   1; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;   2; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;   3; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;   4; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;   5; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;   6; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;   7; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;   8; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;   9; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;  10; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;  11; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;  12; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 123;  13; FUNIL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   335.3;    5;   355.6;   888.0;     0.0;   222.0;\n",
    " 126;   1; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;   2; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;   3; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;   4; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;   5; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;   6; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;   7; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;   8; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;   9; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;  10; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;  11; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;  12; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 126;  13; PICADA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    43.3;    1;     6.9;     6.9;     0.0;    50.0;\n",
    " 127;   1; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;   2; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;   3; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;   4; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;   5; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;   6; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;   7; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;   8; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;   9; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;  10; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;  11; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;  12; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 127;  13; SOBRAGI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    83.8;    1;     0.1;     0.1;     0.0;    60.0;\n",
    " 129;   1; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;   2; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;   3; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;   4; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;   5; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;   6; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;   7; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;   8; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;   9; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;  10; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;  11; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;  12; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 129;  13; SIMPLICIO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   307.1;    1;    13.5;    13.5;     0.0;   305.7;\n",
    " 130;   1; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;   2; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;   3; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;   4; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;   5; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;   6; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;   7; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;   8; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;   9; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;  10; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;  11; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;  12; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 130;  13; ILHA POMBOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   647.0;    1;     5.8;     5.8;     0.0;   187.2;\n",
    " 133;   1; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;   2; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;   3; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;   4; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;   5; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;   6; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;   7; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;   8; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;   9; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;  10; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;  11; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;  12; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 133;  13; P. PASSOS   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   309.0;    1;    16.3;    16.3;     0.0;    99.9;\n",
    " 134;   1; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;   2; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;   3; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;   4; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;   5; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;   6; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;   7; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;   8; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;   9; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;  10; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;  11; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;  12; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 134;  13; SALTO GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   127.2;    1;    67.9;    67.9;     0.0;   102.0;\n",
    " 135;   1; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;   2; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;   3; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;   4; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;   5; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;   6; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;   7; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;   8; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;   9; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;  10; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;  11; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;  12; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 135;  13; P. ESTRELA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   243.2;    5;    61.5;    89.0;     0.0;   112.0;\n",
    " 139;   1; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;   2; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;   3; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;   4; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;   5; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;   6; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;   7; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;   8; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;   9; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;  10; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;  11; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;  12; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 139;  13; CANDONGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   288.5;    1;    14.1;    14.1;     0.0;   140.1;\n",
    " 143;   1; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;   2; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;   3; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;   4; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;   5; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;   6; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;   7; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;   8; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;   9; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;  10; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;  11; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;  12; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 143;  13; AIMORES     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1290.1;    1;   179.3;   179.3;     0.0;   330.0;\n",
    " 144;   1; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;   2; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;   3; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;   4; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;   5; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;   6; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;   7; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;   8; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;   9; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;  10; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;  11; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;  12; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 144;  13; MASCARENHAS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   995.5;    1;    21.7;    21.7;     0.0;   198.0;\n",
    " 192;   1; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;   2; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;   3; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;   4; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;   5; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;   6; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;   7; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;   8; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;   9; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;  10; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;  11; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;  12; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 192;  13; GUILMAN-AMOR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   134.8;    1;    11.3;    11.3;     0.0;   140.0;\n",
    " 193;   1; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;   2; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;   3; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;   4; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;   5; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;   6; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;   7; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;   8; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;   9; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;  10; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;  11; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;  12; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 193;  13; SA CARVALHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    82.9;    1;     1.5;     1.5;     0.0;    78.0;\n",
    " 217;   1; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;   2; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;   3; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;   4; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;   5; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;   6; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;   7; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;   8; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;   9; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;  10; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;  11; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;  12; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 217;  13; ROSAL       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    32.5;    1;    17.2;    17.2;     0.0;    55.0;\n",
    " 279;   1; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;   2; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;   3; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;   4; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;   5; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;   6; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;   7; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;   8; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;   9; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;  10; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;  11; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;  12; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 279;  13; SAMUEL      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   849.1;    5;   943.2;  2248.9;     0.0;   216.7;\n",
    " 148;   1; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;   2; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;   3; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;   4; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;   5; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;   6; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;   7; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;   8; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;   9; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;  10; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;  11; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;  12; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 148;  13; IRAPE       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   265.3;    5;  2267.9;  5705.2;     0.0;   399.0;\n",
    " 283;   1; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;   2; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;   3; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;   4; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;   5; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;   6; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;   7; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;   8; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;   9; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;  10; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;  11; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;  12; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    " 283;  13; STA CLARA MG;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   130.7;    1;   148.4;   148.4;     0.0;    60.0;\n",
    "   1;   1; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;   2; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;   3; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;   4; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;   5; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;   6; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;   7; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;   8; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;   9; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;  10; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;  11; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;  12; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   1;  13; CAMARGOS    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   203.7;    5;   120.0;   608.5;     0.0;    46.0;\n",
    "   2;   1; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;   2; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;   3; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;   4; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;   5; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;   6; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;   7; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;   8; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;   9; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;  10; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;  11; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;  12; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   2;  13; ITUTINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   213.4;    1;    10.6;    10.6;     0.0;    52.0;\n",
    "   6;   1; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;   2; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;   3; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;   4; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;   5; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;   6; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;   7; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;   8; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;   9; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;  10; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;  11; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;  12; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   6;  13; FURNAS      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1577.5;    5;  5733.0; 22037.5;     0.0;  1312.0;\n",
    "   7;   1; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;   2; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;   3; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;   4; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;   5; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;   6; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;   7; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;   8; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;   9; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;  10; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;  11; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;  12; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   7;  13; M. DE MORAES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1158.5;    5;  1752.5;  4040.0;     0.0;   478.0;\n",
    "   8;   1; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;   2; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;   3; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;   4; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;   5; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;   6; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;   7; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;   8; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;   9; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;  10; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;  11; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;  12; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   8;  13; ESTREITO    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2001.1;    1;  1331.4;  1331.4;     0.0;  1104.0;\n",
    "   9;   1; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;   2; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;   3; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;   4; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;   5; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;   6; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;   7; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;   8; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;   9; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;  10; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;  11; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;  12; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "   9;  13; JAGUARA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1075.1;    1;   418.2;   418.2;     0.0;   424.0;\n",
    "  10;   1; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;   2; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;   3; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;   4; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;   5; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;   6; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;   7; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;   8; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;   9; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;  10; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;  11; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;  12; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  10;  13; IGARAPAVA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1446.3;    1;   234.8;   234.8;     0.0;   210.0;\n",
    "  11;   1; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;   2; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;   3; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;   4; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;   5; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;   6; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;   7; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;   8; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;   9; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;  10; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;  11; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;  12; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  11;  13; VOLTA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1531.0;    1;  2200.4;  2200.4;     0.0;   380.0;\n",
    "  12;   1; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;   2; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;   3; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;   4; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;   5; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;   6; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;   7; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;   8; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;   9; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;  10; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;  11; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;  12; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  12;  13; P. COLOMBIA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1630.2;    1;  1420.8;  1420.8;     0.0;   328.0;\n",
    "  14;   1; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;   2; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;   3; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;   4; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;   5; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;   6; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;   7; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;   8; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;   9; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;  10; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;  11; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;  12; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  14;  13; CACONDE     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    86.5;    5;    51.0;   469.3;     0.0;    80.4;\n",
    "  15;   1; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;   2; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;   3; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;   4; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;   5; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;   6; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;   7; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;   8; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;   9; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;  10; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;  11; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;  12; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  15;  13; E. DA CUNHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   143.4;    1;    12.8;    12.8;     0.0;   108.8;\n",
    "  16;   1; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;   2; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;   3; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;   4; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;   5; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;   6; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;   7; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;   8; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;   9; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;  10; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;  11; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;  12; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  16;  13; A.S.OLIVEIRA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.9;    1;    22.8;    22.8;     0.0;    32.0;\n",
    "  17;   1; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;   2; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;   3; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;   4; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;   5; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;   6; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;   7; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;   8; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;   9; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;  10; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;  11; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;  12; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  17;  13; MARIMBONDO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2563.2;    5;   890.0;  6008.0;     0.0;  1488.0;\n",
    "  18;   1; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;   2; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;   3; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;   4; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;   5; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;   6; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;   7; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;   8; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;   9; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;  10; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;  11; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;  12; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  18;  13; A. VERMELHA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2834.0;    5;  7044.9; 11025.0;     0.0;  1396.2;\n",
    "  34;   1; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;   2; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;   3; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;   4; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;   5; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;   6; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;   7; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;   8; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;   9; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;  10; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;  11; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;  12; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  34;  13; I. SOLTEIRA ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  9242.0;    5; 15783.5; 21060.0;     0.0;  3444.0;\n",
    "  24;   1; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;   2; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;   3; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;   4; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;   5; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;   6; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;   7; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;   8; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;   9; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;  10; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;  11; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;  12; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  24;  13; EMBORCACAO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   943.1;    5;  4669.0; 16184.4;     0.0;  1192.0;\n",
    "  25;   1; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;   2; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;   3; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;   4; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;   5; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;   6; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;   7; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;   8; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;   9; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;  10; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;  11; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;  12; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  25;  13; NOVA PONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   588.1;    5;  2412.0;  7996.4;     0.0;   510.0;\n",
    "  26;   1; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;   2; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;   3; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;   4; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;   5; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;   6; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;   7; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;   8; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;   9; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;  10; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;  11; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;  12; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  26;  13; MIRANDA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   668.0;    5;  1010.5;  1120.0;     0.0;   408.0;\n",
    "  30;   1; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;   2; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;   3; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;   4; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;   5; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;   6; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;   7; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;   8; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;   9; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;  10; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;  11; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;  12; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  30;  13; CORUMBA I   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   533.0;    5;   525.6;  1500.0;     0.0;   375.0;\n",
    "  31;   1; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;   2; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;   3; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;   4; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;   5; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;   6; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;   7; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;   8; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;   9; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;  10; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;  11; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;  12; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  31;  13; ITUMBIARA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2714.1;    5;  7761.2; 17027.0;     0.0;  2082.0;\n",
    "  32;   1; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;   2; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;   3; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;   4; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;   5; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;   6; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;   7; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;   8; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;   9; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;  10; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;  11; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;  12; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  32;  13; CACH.DOURADA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2435.2;    1;   465.0;   465.0;     0.0;   658.0;\n",
    "  33;   1; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;   2; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;   3; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;   4; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;   5; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;   6; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;   7; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;   8; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;   9; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;  10; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;  11; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;  12; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  33;  13; SAO SIMAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2565.8;    5;  8124.6; 12540.0;     0.0;  1710.0;\n",
    "  37;   1; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;   2; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;   3; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;   4; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;   5; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;   6; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;   7; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;   8; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;   9; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;  10; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;  11; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;  12; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  37;  13; BARRA BONITA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   701.6;    5;  1123.3;  3135.0;     0.0;   140.0;\n",
    "  38;   1; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;   2; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;   3; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;   4; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;   5; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;   6; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;   7; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;   8; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;   9; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;  10; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;  11; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;  12; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  38;  13; A.S. LIMA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   779.2;    1;   525.2;   525.2;     0.0;   144.0;\n",
    "  39;   1; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;   2; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;   3; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;   4; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;   5; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;   6; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;   7; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;   8; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;   9; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;  10; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;  11; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;  12; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  39;  13; IBITINGA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   730.7;    1;   962.7;   962.7;     0.0;   131.4;\n",
    "  40;   1; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;   2; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;   3; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;   4; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;   5; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;   6; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;   7; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;   8; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;   9; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;  10; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;  11; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;  12; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  40;  13; PROMISSAO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1295.9;    5;  5880.1;  7408.0;     0.0;   264.0;\n",
    "  42;   1; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;   2; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;   3; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;   4; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;   5; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;   6; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;   7; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;   8; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;   9; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;  10; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;  11; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;  12; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  42;  13; NAVANHANDAVA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1247.8;    1;  2666.0;  2666.0;     0.0;   347.4;\n",
    "  43;   1; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;   2; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;   3; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;   4; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;   5; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;   6; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;   7; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;   8; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;   9; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;  10; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;  11; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;  12; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  43;  13; TRES IRMAOS ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2080.9;    5; 10081.7; 13372.0;     0.0;   807.5;\n",
    "  45;   1; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;   2; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;   3; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;   4; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;   5; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;   6; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;   7; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;   8; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;   9; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;  10; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;  11; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;  12; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  45;  13; JUPIA       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8258.3;    1;  3249.1;  3249.1;     0.0;  1551.2;\n",
    "  46;   1; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;   2; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;   3; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;   4; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;   5; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;   6; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;   7; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;   8; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;   9; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;  10; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;  11; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;  12; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    "  46;  13; P. PRIMAVERA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  8779.9;    1; 16138.5; 16138.5;     0.0;  1540.0;\n",
    " 278;   1; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;   2; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;   3; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;   4; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;   5; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;   6; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;   7; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;   8; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;   9; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;  10; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;  11; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;  12; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    " 278;  13; MANSO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   400.3;    5;  4386.0;  6557.9;     0.0;   210.0;\n",
    "  47;   1; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;   2; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;   3; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;   4; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;   5; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;   6; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;   7; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;   8; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;   9; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;  10; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;  11; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;  12; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  47;  13; A.A. LAYDNER;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   365.6;    5;  3843.0;  6875.1;     0.0;   101.0;\n",
    "  49;   1; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;   2; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;   3; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;   4; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;   5; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;   6; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;   7; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;   8; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;   9; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;  10; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;  11; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;  12; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  49;  13; CHAVANTES   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   621.2;    5;  5754.0;  7320.1;     0.0;   414.0;\n",
    "  50;   1; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;   2; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;   3; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;   4; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;   5; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;   6; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;   7; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;   8; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;   9; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;  10; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;  11; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;  12; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  50;  13; L.N. GARCEZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   497.6;    1;    39.0;    39.0;     0.0;    73.8;\n",
    "  51;   1; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;   2; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;   3; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;   4; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;   5; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;   6; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;   7; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;   8; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;   9; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;  10; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;  11; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;  12; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  51;  13; CANOAS II   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.5;    1;   144.7;   144.7;     0.0;    72.0;\n",
    "  52;   1; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;   2; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;   3; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;   4; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;   5; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;   6; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;   7; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;   8; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;   9; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;  10; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;  11; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;  12; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  52;  13; CANOAS I    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   554.1;    1;   205.8;   205.8;     0.0;    82.5;\n",
    "  61;   1; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;   2; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;   3; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;   4; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;   5; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;   6; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;   7; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;   8; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;   9; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;  10; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;  11; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;  12; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  61;  13; CAPIVARA    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1444.0;    5;  4816.0;  8095.9;     0.0;   643.0;\n",
    "  62;   1; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;   2; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;   3; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;   4; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;   5; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;   6; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;   7; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;   8; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;   9; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;  10; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;  11; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;  12; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  62;  13; TAQUARUCU   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2363.8;    1;   649.6;   649.6;     0.0;   525.0;\n",
    "  63;   1; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;   2; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;   3; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;   4; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;   5; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;   6; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;   7; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;   8; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;   9; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;  10; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;  11; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;  12; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  63;  13; ROSANA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1922.9;    1;  1847.6;  1847.6;     0.0;   354.0;\n",
    "  57;   1; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;   2; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;   3; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;   4; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;   5; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;   6; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;   7; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;   8; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;   9; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;  10; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;  11; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;  12; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  57;  13; MAUA        ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.3;    5;  1473.0;  2017.5;     0.0;   352.1;\n",
    "  71;   1; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;   2; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;   3; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;   4; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;   5; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;   6; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;   7; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;   8; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;   9; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;  10; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;  11; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;  12; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  71;  13; STA CLARA PR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   158.0;    5;   169.0;   300.0;     0.0;   120.2;\n",
    "  72;   1; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;   2; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;   3; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;   4; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;   5; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;   6; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;   7; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;   8; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;   9; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;  10; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;  11; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;  12; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  72;  13; FUNDAO      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   144.7;    1;    34.5;    34.5;     0.0;   120.2;\n",
    "  74;   1; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;   2; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;   3; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;   4; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;   5; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;   6; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;   7; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;   8; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;   9; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;  10; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;  11; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;  12; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  74;  13; G.B. MUNHOZ ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1243.2;    5;  1974.0;  4580.4;     0.0;  1676.0;\n",
    "  83;   1; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;   2; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;   3; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;   4; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;   5; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;   6; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;   7; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;   8; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;   9; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;  10; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;  11; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;  12; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  83;  13; BAIXO IGUACU;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2401.9;    1;   201.2;   201.2;     0.0;   350.2;\n",
    "  86;   1; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;   2; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;   3; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;   4; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;   5; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;   6; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;   7; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;   8; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;   9; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;  10; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;  11; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;  12; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  86;  13; BARRA GRANDE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   495.9;    5;  2711.8;  3930.9;     0.0;   690.0;\n",
    "  88;   1; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;     0.0;\n",
    "  88;   2; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;     0.0;\n",
    "  88;   3; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;     0.0;\n",
    "  88;   4; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;     0.0;\n",
    "  88;   5; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;     0.0;\n",
    "  88;   6; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;     0.0;\n",
    "  88;   7; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;     0.0;\n",
    "  88;   8; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;     0.0;\n",
    "  88;   9; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;     0.0;\n",
    "  88;  10; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;    47.3;\n",
    "  88;  11; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;    47.3;\n",
    "  88;  12; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;    94.6;\n",
    "  88;  13; SAO ROQUE   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;     0.0;    5;   336.7;   566.2;     0.0;   141.9;\n",
    "  89;   1; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;   2; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;   3; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;   4; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;   5; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;   6; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;   7; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;   8; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;   9; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;  10; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;  11; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;  12; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  89;  13; GARIBALDI   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   522.1;    5;   250.4;   296.0;     0.0;   189.0;\n",
    "  90;   1; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;   2; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;   3; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;   4; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;   5; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;   6; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;   7; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;   8; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;   9; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;  10; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;  11; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;  12; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  90;  13; CAMPOS NOVOS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   543.2;    5;  1383.7;  1477.0;     0.0;   880.0;\n",
    "  91;   1; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;   2; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;   3; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;   4; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;   5; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;   6; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;   7; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;   8; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;   9; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;  10; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;  11; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;  12; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  91;  13; MACHADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1261.7;    5;  2283.0;  3115.9;     0.0;  1140.0;\n",
    "  92;   1; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;   2; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;   3; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;   4; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;   5; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;   6; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;   7; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;   8; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;   9; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;  10; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;  11; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;  12; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  92;  13; ITA         ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1588.0;    1;  4924.3;  4924.3;     0.0;  1450.0;\n",
    "  93;   1; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;   2; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;   3; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;   4; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;   5; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;   6; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;   7; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;   8; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;   9; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;  10; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;  11; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;  12; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  93;  13; PASSO FUNDO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   103.4;    5;   185.0;  1363.0;     0.0;   226.0;\n",
    "  94;   1; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;   2; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;   3; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;   4; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;   5; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;   6; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;   7; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;   8; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;   9; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;  10; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;  11; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;  12; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  94;  13; MONJOLINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   137.0;    1;   147.3;   147.3;     0.0;    74.0;\n",
    "  95;   1; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;   2; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;   3; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;   4; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;   5; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;   6; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;   7; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;   8; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;   9; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;  10; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;  11; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;  12; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    "  95;  13; QUEBRA QUEIX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   116.7;    5;   111.0;   135.7;     0.0;   120.0;\n",
    " 101;   1; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;   2; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;   3; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;   4; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;   5; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;   6; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;   7; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;   8; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;   9; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;  10; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;  11; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;  12; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 101;  13; SAO JOSE    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   271.6;    1;   178.8;   178.8;     0.0;    51.0;\n",
    " 102;   1; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;   2; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;   3; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;   4; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;   5; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;   6; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;   7; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;   8; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;   9; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;  10; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;  11; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;  12; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 102;  13; PASSO S JOAO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   302.6;    1;    96.0;    96.0;     0.0;    77.0;\n",
    " 103;   1; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;   2; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;   3; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;   4; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;   5; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;   6; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;   7; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;   8; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;   9; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;  10; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;  11; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;  12; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    " 103;  13; FOZ CHAPECO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1897.5;    1;  1466.2;  1466.2;     0.0;   855.0;\n",
    "  97;   1; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;   2; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;   3; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;   4; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;   5; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;   6; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;   7; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;   8; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;   9; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;  10; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;  11; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;  12; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  97;  13; CASTRO ALVES;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   157.1;    1;    92.5;    92.5;     0.0;   130.0;\n",
    "  98;   1; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;   2; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;   3; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;   4; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;   5; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;   6; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;   7; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;   8; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;   9; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;  10; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;  11; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;  12; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  98;  13; MONTE CLARO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   367.1;    1;    11.3;    11.3;     0.0;   130.0;\n",
    "  99;   1; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;   2; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;   3; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;   4; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;   5; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;   6; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;   7; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;   8; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;   9; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;  10; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;  11; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;  12; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    "  99;  13; 14 DE JULHO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   331.6;    1;    55.4;    55.4;     0.0;   100.0;\n",
    " 111;   1; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;   2; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;   3; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;   4; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;   5; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;   6; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;   7; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;   8; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;   9; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;  10; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;  11; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;  12; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 111;  13; PASSO REAL  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   462.4;    5;   289.0;  2511.3;     0.0;   158.0;\n",
    " 112;   1; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;   2; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;   3; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;   4; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;   5; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;   6; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;   7; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;   8; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;   9; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;  10; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;  11; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;  12; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 112;  13; JACUI       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   226.4;    1;    19.6;    19.6;     0.0;   180.0;\n",
    " 113;   1; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;   2; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;   3; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;   4; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;   5; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;   6; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;   7; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;   8; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;   9; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;  10; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;  11; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;  12; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 113;  13; ITAUBA      ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   612.4;    1;   594.9;   594.9;     0.0;   500.0;\n",
    " 114;   1; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;   2; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;   3; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;   4; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;   5; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;   6; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;   7; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;   8; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;   9; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;  10; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;  11; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;  12; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 114;  13; D. FRANCISCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   369.0;    1;   320.4;   320.4;     0.0;   125.0;\n",
    " 115;   1; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;   2; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;   3; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;   4; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;   5; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;   6; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;   7; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;   8; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;   9; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;  10; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;  11; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;  12; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 115;  13; G.P. SOUZA  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;    40.1;    5;    23.0;   162.5;     0.0;   260.0;\n",
    " 215;   1; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;   2; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;   3; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;   4; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;   5; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;   6; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;   7; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;   8; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;   9; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;  10; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;  11; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;  12; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    " 215;  13; SALTO PILAO ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   108.8;    1;     0.3;     0.3;     0.0;   191.9;\n",
    "  76;   1; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;   2; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;   3; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;   4; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;   5; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;   6; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;   7; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;   8; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;   9; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;  10; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;  11; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;  12; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  76;  13; SEGREDO     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1233.8;    5;  2562.0;  2906.2;     0.0;  1260.0;\n",
    "  77;   1; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;   2; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;   3; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;   4; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;   5; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;   6; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;   7; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;   8; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;   9; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;  10; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;  11; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;  12; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  77;  13; SLT.SANTIAGO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1449.8;    5;  2740.1;  6775.0;     0.0;  1420.0;\n",
    "  78;   1; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;   2; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;   3; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;   4; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;   5; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;   6; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;   7; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;   8; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;   9; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;  10; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;  11; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;  12; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  78;  13; SALTO OSORIO;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1844.5;    1;  1090.9;  1090.9;     0.0;  1078.0;\n",
    "  82;   1; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;   2; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;   3; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;   4; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;   5; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;   6; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;   7; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;   8; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;   9; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;  10; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;  11; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;  12; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    "  82;  13; SALTO CAXIAS;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2174.0;    1;  3472.5;  3472.5;     0.0;  1240.0;\n",
    " 169;   1; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;   2; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;   3; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;   4; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;   5; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;   6; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;   7; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;   8; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;   9; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;  10; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;  11; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;  12; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 169;  13; SOBRADINHO  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4230.3;    5;  6823.1; 34116.0;     0.0;  1050.0;\n",
    " 172;   1; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;   2; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;   3; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;   4; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;   5; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;   6; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;   7; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;   8; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;   9; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;  10; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;  11; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;  12; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 172;  13; ITAPARICA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  3268.6;    5;  7439.8; 10782.0;     0.0;  1479.6;\n",
    " 176;   1; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;   2; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;   3; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;   4; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;   5; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;   6; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;   7; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;   8; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;   9; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;  10; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;  11; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;  12; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 176;  13; COMP PAF-MOX;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  4190.3;    1;  1212.0;  1212.0;     0.0;  4279.6;\n",
    " 178;   1; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;   2; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;   3; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;   4; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;   5; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;   6; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;   7; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;   8; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;   9; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;  10; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;  11; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;  12; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 178;  13; XINGO       ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2932.9;    1;  3773.0;  3773.0;     0.0;  3162.0;\n",
    " 154;   1; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;   2; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;   3; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;   4; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;   5; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;   6; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;   7; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;   8; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;   9; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;  10; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;  11; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;  12; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 154;  13; ITAPEBI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   646.2;    1;  1613.1;  1613.1;     0.0;   462.0;\n",
    " 189;   1; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;   2; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;   3; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;   4; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;   5; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;   6; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;   7; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;   8; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;   9; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;  10; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;  11; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;  12; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 189;  13; P. CAVALO   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   173.3;    5;  2537.7;  3134.0;     0.0;   160.0;\n",
    " 190;   1; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;   2; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;   3; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;   4; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;   5; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;   6; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;   7; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;   8; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;   9; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;  10; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;  11; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;  12; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 190;  13; B. ESPERANCA;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   616.8;    5;  3239.9;  5085.0;     0.0;   237.3;\n",
    " 204;   1; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;   2; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;   3; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;   4; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;   5; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;   6; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;   7; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;   8; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;   9; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;  10; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;  11; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;  12; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 204;  13; CACH.CALDEIR;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1557.6;    1;   225.3;   225.3;     0.0;   219.0;\n",
    " 267;   1; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;   2; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;   3; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;   4; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;   5; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;   6; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;   7; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;   8; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;   9; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;  10; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;  11; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;  12; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 267;  13; ESTREITO TOC;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  5151.7;    1;  4944.5;  4944.5;     0.0;  1087.0;\n",
    " 275;   1; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13404.3;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;   2; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13404.3;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;   3; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13180.7;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;   4; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13098.3;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;   5; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13294.5;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;   6; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.4;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;   7; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13874.4;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;   8; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13874.4;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;   9; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13874.4;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;  10; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13874.4;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;  11; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13874.4;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;  12; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13874.4;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 275;  13; TUCURUI     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13636.3;    5; 30784.0; 50275.0;     0.0;  8535.0;\n",
    " 277;   1; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;   2; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;   3; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;   4; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;   5; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;   6; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;   7; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;   8; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;   9; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;  10; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;  11; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;  12; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 277;  13; BALBINA     ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1282.9;    5;  9711.9; 18657.7;     0.0;   249.8;\n",
    " 280;   1; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;   2; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;   3; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;   4; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;   5; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;   6; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;   7; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;   8; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;   9; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;  10; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;  11; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;  12; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 280;  13; COARACY NUNE;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   393.3;    1;   135.4;   135.4;     0.0;    78.0;\n",
    " 284;   1; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;   2; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;   3; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;   4; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;   5; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;   6; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;   7; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;   8; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;   9; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;  10; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;  11; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;  12; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 284;  13; FERREIRA GOM;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1681.1;    1;   123.3;   123.3;     0.0;   252.0;\n",
    " 286;   1; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;   2; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;   3; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;   4; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;   5; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;   6; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;   7; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;   8; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;   9; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;  10; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;  11; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;  12; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 286;  13; STO ANT JARI;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  1682.7;    1;   133.1;   133.1;     0.0;   389.6;\n",
    " 314;   1; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;   2; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;   3; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;   4; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;   5; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;   6; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;   7; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;   8; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;   9; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;  10; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;  11; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;  12; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 314;  13; PIMENTAL    ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;  2004.3;    1;  4802.3;  4802.3;     0.0;   233.1;\n",
    " 272;   1; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;   2; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;   3; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;   4; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;   5; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;   6; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;   7; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;   8; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;   9; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;  10; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;  11; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;  12; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 272;  13; CURUA-UNA   ;  2 ;  1 ;  1 ;  1 ;    5;     0.0;   181.4;    5;   367.5;   602.0;     0.0;    30.3;\n",
    " 288;   1; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;   2; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;   3; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;   4; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;   5; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;   6; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;   7; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;   8; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;   9; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;  10; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;  11; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;  12; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    " 288;  13; BELO MONTE  ;  2 ;  1 ;  1 ;  1 ;    5;     0.0; 13695.2;    1;  4802.3;  4802.3;     0.0; 11000.0;\n",
    "----;----;-------------;----;----;----;----;----;--------;--------;----;--------;--------;--------;--------;\n",
]
